<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Part.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Part.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Part.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;ASG Formatting classes.</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-string"/></span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-string">This module contains classes for formatting parts of a scope view (class,</span></span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-string">module, etc with methods, variables etc. The actual formatting of the</span></span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-string">declarations is delegated to multiple strategies for each part of the view,</span></span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-string">and are defined in the FormatStrategy module.</span></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parametrized, Parameter</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">from</span> Fragment <span class="py-keyword">import</span> Fragment</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-keyword">import</span> Tags <span class="py-comment"># need both because otherwise 'Tags.name' would be ambiguous</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-keyword">from</span> Tags <span class="py-keyword">import</span> *</span>
<a id="line22"></a><span class="lineno"> 22</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html">Part</a>(Parametrized, ASG.Visitor):</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Base class for formatting a Part of a Scope View.</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-string">    </span></span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line"><span class="py-string">    This class contains functionality for modularly formatting an ASG node and</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="py-string">    its children for display. It is typically used to construct Heading,</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="py-string">    Summary and Detail formatters. Strategy objects are added according to</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-string">    configuration, and this base class  then checks which format methods each</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="py-string">    strategy implements. For each ASG declaration visited, the Part asks all</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line"><span class="py-string">    Strategies which implement the appropriate format method to generate</span></span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="py-string">    output for that declaration. The final writing of the formatted html is</span></span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line"><span class="py-string">    delegated to the write_section_start, write_section_end, and write_section_item</span></span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-string">    methods, which must be implemented in a subclass.</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">    fragments = Parameter([], <span class="py-string">&quot;list of Fragments&quot;</span>)</span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#register">register</a>(self, view):</span>
<a id="line40"></a><span class="lineno"> 40</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        self.processor = view.processor</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        self.__view = view</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">        self.__fragments = []</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">        self.__id_holder = None</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        <span class="py-comment"># Lists of format methods for each ASG type</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        self.__formatdict = {<span class="py-string">'format_declaration'</span>:[],</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">                             <span class="py-string">'format_macro'</span>:[],</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">                             <span class="py-string">'format_forward'</span>:[],</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">                             <span class="py-string">'format_group'</span>:[],</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">                             <span class="py-string">'format_scope'</span>:[],</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">                             <span class="py-string">'format_module'</span>:[],</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">                             <span class="py-string">'format_meta_module'</span>:[],</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">                             <span class="py-string">'format_class'</span>:[],</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">                             <span class="py-string">'format_class_template'</span>:[],</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">                             <span class="py-string">'format_typedef'</span>:[],</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">                             <span class="py-string">'format_enum'</span>:[],</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">                             <span class="py-string">'format_variable'</span>:[],</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">                             <span class="py-string">'format_const'</span>:[],</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">                             <span class="py-string">'format_function'</span>:[],</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">                             <span class="py-string">'format_function_template'</span>:[],</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">                             <span class="py-string">'format_operation'</span>:[],</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">                             <span class="py-string">'format_operation_template'</span>:[]}</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        <span class="py-keyword">for</span> fragment <span class="py-keyword">in</span> self.fragments:</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">            fragment.register(self)</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">            <span class="py-keyword">for</span> method <span class="py-keyword">in</span> self.__formatdict.keys():</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">                no_func = getattr(Fragment, method).im_func</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">                method_obj = getattr(fragment, method)</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">                <span class="py-comment"># If it was overridden in fragment</span></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">                <span class="py-keyword">if</span> method_obj.im_func <span class="py-keyword">is</span> <span class="py-keyword">not</span> no_func:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">                    <span class="py-comment"># Add to the dictionary</span></span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">                    self.__formatdict[method].append(method_obj)</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#view">view</a>(self): <span class="py-keyword">return</span> self.__view</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#filename">filename</a>(self): <span class="py-keyword">return</span> self.__view.filename()</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#os">os</a>(self): <span class="py-keyword">return</span> self.__view.os()</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#scope">scope</a>(self): <span class="py-keyword">return</span> self.__view.scope()</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#write">write</a>(self, text): self.os().write(text)</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <span class="py-comment"># Access to generated values</span></span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#type_ref">type_ref</a>(self): <span class="py-keyword">return</span> self.__type_ref</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#type_label">type_label</a>(self): <span class="py-keyword">return</span> self.__type_label</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#declarator">declarator</a>(self): <span class="py-keyword">return</span> self.__declarator</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#parameter">parameter</a>(self): <span class="py-keyword">return</span> self.__parameter</span>
<a id="line85"></a><span class="lineno"> 85</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#reference">reference</a>(self, name, label=None, **keys):</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a reference to the given name. The name is a scoped name,</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line"><span class="py-string">        and the optional label is an alternative name to use as the link text.</span></span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line"><span class="py-string">        The name is looked up in the TOC so the link may not be local. The</span></span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line"><span class="py-string">        optional keys are appended as attributes to the A tag.&quot;&quot;&quot;</span></span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> label: label = escape(str(self.scope().prune(name)))</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        entry = self.processor.toc[name]</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        <span class="py-keyword">if</span> entry: <span class="py-keyword">return</span> href(rel(self.filename(), entry.link), label, **keys)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        <span class="py-keyword">else</span>: <span class="py-keyword">return</span> label <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#label">label</a>(self, name, label=None):</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Create a label for the given name. The label is an anchor so it can</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line"><span class="py-string">        be referenced by other links. The name of the label is derived by</span></span>
<a id="line100"></a><span class="lineno">100</span><span class="line"><span class="py-string">        looking up the name in the TOC and using the link in the TOC entry.</span></span>
<a id="line101"></a><span class="lineno">101</span><span class="line"><span class="py-string">        The optional label is an alternative name to use as the displayed</span></span>
<a id="line102"></a><span class="lineno">102</span><span class="line"><span class="py-string">        name. If the name is not found in the TOC then the name is not</span></span>
<a id="line103"></a><span class="lineno">103</span><span class="line"><span class="py-string">        anchored and just label is returned (or name if no label is given).</span></span>
<a id="line104"></a><span class="lineno">104</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">        <span class="py-keyword">if</span> label <span class="py-keyword">is</span> None: label = name</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        <span class="py-comment"># some labels are templates with &lt;&gt;'s</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        entry = self.processor.toc[name]</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        label = escape(str(self.scope().prune(label)))</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">        <span class="py-keyword">if</span> entry <span class="py-keyword">is</span> None: <span class="py-keyword">return</span> label</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">        location = entry.link</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        index = location.find(<span class="py-string">'#'</span>)</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        <span class="py-keyword">if</span> index &gt;= 0: location = location[index+1:]</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        <span class="py-keyword">return</span> location <span class="py-keyword">and</span> Tags.name(location, label) <span class="py-keyword">or</span> label</span>
<a id="line115"></a><span class="lineno">115</span>
<a id="line116"></a><span class="lineno">116</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#format_declaration">format_declaration</a>(self, decl, method):</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Format decl using named method of each fragment. Each fragment</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line"><span class="py-string">        returns two strings - type and name. All the types are joined and all</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line"><span class="py-string">        the names are joined separately. The consolidated type and name</span></span>
<a id="line121"></a><span class="lineno">121</span><span class="line"><span class="py-string">        strings are then passed to write_section_item.&quot;&quot;&quot;</span></span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        type_name = [f(decl) <span class="py-keyword">for</span> f <span class="py-keyword">in</span> self.__formatdict[method]]</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        <span class="py-keyword">if</span> type_name:</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">            text = <span class="py-string">' '</span>.join(type_name).strip()</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">            self.write_section_item(text)</span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#process">process</a>(self, decl):</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats the given decl, creating the output for this Part of the</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line"><span class="py-string">        view. This method is implemented in various subclasses in different</span></span>
<a id="line131"></a><span class="lineno">131</span><span class="line"><span class="py-string">        ways, for example Summary and Detail iterate through the children of</span></span>
<a id="line132"></a><span class="lineno">132</span><span class="line"><span class="py-string">        'decl' section by section, whereas Heading only formats decl itself.</span></span>
<a id="line133"></a><span class="lineno">133</span><span class="line"><span class="py-string">        &quot;&quot;&quot;</span></span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">    <span class="py-comment">#################### ASG Visitor ############################################</span></span>
<a id="line138"></a><span class="lineno">138</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_declaration">visit_declaration</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_declaration'</span>)</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_macro">visit_macro</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_macro'</span>)</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_forward">visit_forward</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_forward'</span>)</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_group">visit_group</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_group'</span>)</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_scope">visit_scope</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_scope'</span>)</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_module">visit_module</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_module'</span>)</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_meta_module">visit_meta_module</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_meta_module'</span>)</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_class">visit_class</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_class'</span>)</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_class_template">visit_class_template</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_class_template'</span>)</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_typedef">visit_typedef</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_typedef'</span>)</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_enum">visit_enum</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_enum'</span>)</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_variable">visit_variable</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_variable'</span>)</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_const">visit_const</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_const'</span>)</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_function">visit_function</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_function'</span>)</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_function_template">visit_function_template</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_function_template'</span>)</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_operation">visit_operation</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_operation'</span>)</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_operation_template">visit_operation_template</a>(self, decl): self.format_declaration(decl, <span class="py-string">'format_operation_template'</span>)</span>
<a id="line155"></a><span class="lineno">155</span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">    <span class="py-comment">#################### Type Formatter/Visitor #################################</span></span>
<a id="line158"></a><span class="lineno">158</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#format_type">format_type</a>(self, typeObj, id_holder = None):</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">        <span class="py-string">&quot;Returns a reference string for the given type object&quot;</span></span>
<a id="line160"></a><span class="lineno">160</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        <span class="py-keyword">if</span> typeObj <span class="py-keyword">is</span> None: <span class="py-keyword">return</span> <span class="py-string">&quot;(unknown)&quot;</span></span>
<a id="line162"></a><span class="lineno">162</span><span class="line">        <span class="py-keyword">if</span> id_holder:</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">            save_id = self.__id_holder</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">            self.__id_holder = id_holder</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">        typeObj.accept(self)</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">        <span class="py-keyword">if</span> id_holder:</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">            self.__id_holder = save_id</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        <span class="py-keyword">return</span> self.__type_label</span>
<a id="line169"></a><span class="lineno">169</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type):</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        <span class="py-string">&quot;Sets the label to be a reference to the type's name&quot;</span></span>
<a id="line172"></a><span class="lineno">172</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">        self.__type_label = self.reference(type.name)</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type):</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        <span class="py-string">&quot;Sets the label to be a reference to the type's link&quot;</span></span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        self.__type_label = self.reference(type.link)</span>
<a id="line179"></a><span class="lineno">179</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_declared_type_id">visit_declared_type_id</a>(self, type):</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">        <span class="py-string">&quot;Sets the label to be a reference to the type's name&quot;</span></span>
<a id="line182"></a><span class="lineno">182</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">        self.__type_label = self.reference(type.name)</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_dependent_type_id">visit_dependent_type_id</a>(self, type):</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">        <span class="py-string">&quot;Sets the label to be the type's name (which has no proper scope)&quot;</span></span>
<a id="line187"></a><span class="lineno">187</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">        self.__type_label = type.name[-1]</span>
<a id="line189"></a><span class="lineno">189</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type):</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">        <span class="py-string">&quot;Adds modifiers to the formatted label of the modifier's alias&quot;</span></span>
<a id="line192"></a><span class="lineno">192</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">        alias = self.format_type(type.alias)</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">        <span class="py-keyword">def</span> amp(x):</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">            <span class="py-keyword">if</span> x == <span class="py-string">'&amp;'</span>: <span class="py-keyword">return</span> <span class="py-string">'&amp;amp;'</span></span>
<a id="line196"></a><span class="lineno">196</span><span class="line">            <span class="py-keyword">return</span> x</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">        pre = <span class="py-string">''</span>.join([<span class="py-string">'%s&amp;#160;'</span>%amp(x) <span class="py-keyword">for</span> x <span class="py-keyword">in</span> type.premod])</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">        post = <span class="py-string">''</span>.join([amp(x) <span class="py-keyword">for</span> x <span class="py-keyword">in</span> type.postmod])</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">        self.__type_label = <span class="py-string">&quot;%s%s%s&quot;</span>%(pre,alias,post)</span>
<a id="line200"></a><span class="lineno">200</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type):</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">        <span class="py-string">&quot;Adds the parameters to the template name in angle brackets&quot;</span></span>
<a id="line203"></a><span class="lineno">203</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">        <span class="py-keyword">if</span> type.template:</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">            type_label = self.reference(type.template.name)</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">            type_label = <span class="py-string">&quot;(unknown)&quot;</span></span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        parameters = [self.format_type(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters]</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">        self.__type_label = <span class="py-string">&quot;%s&amp;lt;%s&amp;gt;&quot;</span>%(type_label,<span class="py-string">', '</span>.join(parameters))</span>
<a id="line210"></a><span class="lineno">210</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_template_id">visit_template_id</a>(self, type):</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">        <span class="py-string">&quot;Labs the template with the parameters&quot;</span></span>
<a id="line213"></a><span class="lineno">213</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">        self.__type_label = <span class="py-string">&quot;template&amp;lt;%s&amp;gt;&quot;</span>%<span class="py-string">','</span>.join([<span class="py-string">'typename %s'</span>%self.format_type(p)</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">                                                           <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters])</span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#visit_function_type_id">visit_function_type_id</a>(self, type):</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">        <span class="py-string">&quot;Labels the function type with return type, name and parameters&quot;</span></span>
<a id="line219"></a><span class="lineno">219</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">        ret = self.format_type(type.return_type)</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">        params = map(self.format_type, type.parameters)</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">        pre = <span class="py-string">''</span>.join(type.premod)</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">        <span class="py-keyword">if</span> self.__id_holder:</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">            ident = self.__id_holder[0]</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">            <span class="py-keyword">del</span> self.__id_holder[0]</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">            ident = <span class="py-string">''</span></span>
<a id="line228"></a><span class="lineno">228</span><span class="line">        self.__type_label = <span class="py-string">&quot;%s(%s%s)(%s)&quot;</span>%(ret,pre,ident,<span class="py-string">', '</span>.join(params))</span>
<a id="line229"></a><span class="lineno">229</span>
<a id="line230"></a><span class="lineno">230</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">    <span class="py-comment"># These are overridden in {Summary,Detail}Formatter</span></span>
<a id="line232"></a><span class="lineno">232</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#write_start">write_start</a>(self):</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">        <span class="py-string">&quot;Abstract method to start the output, eg table headings&quot;</span></span>
<a id="line234"></a><span class="lineno">234</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">        self.write(<span class="py-string">'&lt;!-- this part was generated by '</span> + self.__class__.__name__ + <span class="py-string">' --&gt;\n'</span>)</span>
<a id="line236"></a><span class="lineno">236</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#write_section_start">write_section_start</a>(self, heading):</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">        <span class="py-string">&quot;Abstract method to start a section of declaration types&quot;</span></span>
<a id="line239"></a><span class="lineno">239</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line241"></a><span class="lineno">241</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#write_section_end">write_section_end</a>(self, heading):</span>
<a id="line243"></a><span class="lineno">243</span><span class="line">        <span class="py-string">&quot;Abstract method to end a section of declaration types&quot;</span></span>
<a id="line244"></a><span class="lineno">244</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line246"></a><span class="lineno">246</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#write_section_item">write_section_item</a>(self, text):</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">        <span class="py-string">&quot;Abstract method to write the output of one formatted declaration&quot;</span></span>
<a id="line249"></a><span class="lineno">249</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line251"></a><span class="lineno">251</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/HTML/Part/Part.html#write_end">write_end</a>(self):</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">        <span class="py-string">&quot;Abstract method to end the output, eg close the table&quot;</span></span>
<a id="line254"></a><span class="lineno">254</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line256"></a><span class="lineno">256</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
